Subject: [quicwg/base-drafts] b37554: Rework Retry packet

From: Martin Thomson <[email-masked]>
Date: Mon, 30 Jul 2018 22:13:08 -0700

Branch: refs/heads/master
  Home:   https://github.com/quicwg/base-drafts
  Commit: b3755446d985d542105628c0a6509328976e89da
      https://github.com/quicwg/base-drafts/commit/b3755446d985d542105628c0a6509328976e89da
  Author: Martin Thomson <[email-masked]>
  Date:   2018-06-29 (Fri, 29 Jun 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Rework Retry packet

This includes several changes:

* I moved the Retry packet description.  It is more like Version Negotiation than Handshake or Initial, so it made sense to move it up.

* Retry doesn't include a packet number or payload.  Like Version Negotiation, it includes a complete definition.

* As discussed in #1451, this requires a server that might send another Retry to provide a connection ID of at least 8 octets.

* I clarified the description of fields, expanded the pictures, and made some other editorial tweaks.

Open Question: would it make sense to normalize the encoding of Retry and Initial?  The former includes a token without a length (because it's the last piece of the packet), whereas the latter includes a length-prefixed token.  It might be easier to invert the ODCID and token on Retry.  That would make the token processing more consistent.  I'm not sure if we want to consider adding a token to 0-RTT and Handshake packets, but that would fully normalize things.

Closes #1492, #1451.

  Commit: bf3f67597f3315018d348bfcf638d8fb9379ff0f
      https://github.com/quicwg/base-drafts/commit/bf3f67597f3315018d348bfcf638d8fb9379ff0f
  Author: Martin Thomson <[email-masked]>
  Date:   2018-06-29 (Fri, 29 Jun 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Review comments

  Commit: 55e910f476f56ede4f13ff506378f74a0e488444
      https://github.com/quicwg/base-drafts/commit/55e910f476f56ede4f13ff506378f74a0e488444
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-03 (Tue, 03 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Address various comments

  Commit: fdb837fc8cd9b20486007f377411ff8fb98f1066
      https://github.com/quicwg/base-drafts/commit/fdb837fc8cd9b20486007f377411ff8fb98f1066
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-03 (Tue, 03 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Collapse a few things

  Commit: dd13b0e26724445d20353a8eb382a99edc5734cc
      https://github.com/quicwg/base-drafts/commit/dd13b0e26724445d20353a8eb382a99edc5734cc
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-03 (Tue, 03 Jul 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Add PN offset calculation adjustment for Initial packet

  Commit: c96058fc6423de0fa332f09cd500b68e1fd5ca36
      https://github.com/quicwg/base-drafts/commit/c96058fc6423de0fa332f09cd500b68e1fd5ca36
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-06 (Fri, 06 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Grammar hard

  Commit: e3756579b43c43b002afa71ce5818341ec5c114b
      https://github.com/quicwg/base-drafts/commit/e3756579b43c43b002afa71ce5818341ec5c114b
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-09 (Mon, 09 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Redo ODCIL encoding.  Closes #1535.

  Commit: 555ae817e5e7fb37dfb1167d08c37c8ecf901dc0
      https://github.com/quicwg/base-drafts/commit/555ae817e5e7fb37dfb1167d08c37c8ecf901dc0
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-09 (Mon, 09 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Tweak language

  Commit: 19174cfecc237a4c7e772a40992631a25a124c6f
      https://github.com/quicwg/base-drafts/commit/19174cfecc237a4c7e772a40992631a25a124c6f
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-09 (Mon, 09 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Grammar fixes, leftover invalid text

  Commit: 21f9ba5250712726f1112695a8d8a168a567c693
      https://github.com/quicwg/base-drafts/commit/21f9ba5250712726f1112695a8d8a168a567c693
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-09 (Mon, 09 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Refine token use and reuse constraints

  Commit: 7d96aa94e314fc26dc4c241865dca8036e842d6f
      https://github.com/quicwg/base-drafts/commit/7d96aa94e314fc26dc4c241865dca8036e842d6f
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-12 (Thu, 12 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  FOUR bits

  Commit: dbc58a158b1bbeb2043d2224e2eba01bc38b6347
      https://github.com/quicwg/base-drafts/commit/dbc58a158b1bbeb2043d2224e2eba01bc38b6347
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-12 (Thu, 12 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  ODCIL will never be <8

  Commit: cd9cdb48daea18b3f9b10e3459df09e833dcad32
      https://github.com/quicwg/base-drafts/commit/cd9cdb48daea18b3f9b10e3459df09e833dcad32
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-14 (Sat, 14 Jul 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  a new value

  Commit: 85f58c060fcdec2c26c16c3d0f4d3915c8500a5f
      https://github.com/quicwg/base-drafts/commit/85f58c060fcdec2c26c16c3d0f4d3915c8500a5f
  Author: Martin Thomson <[email-masked]>
  Date:   2018-07-31 (Tue, 31 Jul 2018)

  Changed paths:
    M draft-ietf-quic-tls.md
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Merge pull request #1498 from quicwg/move-retry

Rework Retry packet

Compare: https://github.com/quicwg/base-drafts/compare/231a518591e4...85f58c060fcd
      **NOTE:** This service has been marked for deprecation: https://developer.github.com/changes/2018-04-25-github-services-deprecation/

      Functionality will be removed from GitHub.com on January 31st, 2019.